/**
 * Copyright (c) Members of the EGEE Collaboration. 2007-2010. 
 * See http://www.eu-egee.org/partners/ for details on the copyright
 * holders.  
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *
 *
 *  Authors:
 *  2007-
 *     Oscar Koeroo <okoeroo@nikhef.nl>
 *     David Groep <davidg@nikhef.nl>
 *     NIKHEF Amsterdam, the Netherlands
 *     <grid-mw-security@nikhef.nl> 
 *
 *
 */


#include <stdio.h>
#include <stdlib.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/socket.h>

#include <unistd.h>

#include <sys/time.h>
#include <string.h>



#ifndef NET_COMMON_H
  #define NET_COMMON_H


#define TRUE   1
#define FALSE  0

#define HOSTNAME_MAX_CHARS      512
#define IP_MAX_CHARS            64
#define PORT_MAX_DIGITS         6
#define PREFIX_V4_MAPPED        "::ffff:"



void getIPString(char *ip, int ip_length, struct sockaddr *paddress);
/*
int net_addr2host (char **                 hostname,
                   int                     bufsize,
                   struct sockaddr    *    ss);
*/
int net_addr2host (char **                     hostname,
                   int                         bufsize,
                   struct sockaddr_storage   * ss);
int setup_master_socket (int * master_socket, int port);
int accept_new_client_socket (int master_socket, 
                              int * client_socket, 
                              struct sockaddr_storage *addr,
                              socklen_t *addr_len,
                              char ** remote_host);
int create_client_socket (int * client_socket, 
                          const char * server, 
                          int port, 
                          int time_out_seconds);

int createAndSetUpATCPServerSocket(unsigned short port, int max_connections);

#ifdef DEPRECATED_CODE
int addr2host (char ** hostname, int bufsize, struct sockaddr_in addr);
int getHostnameFromAddr (char **                 hostname,
                         int                     bufsize,
                         struct sockaddr_storage ss);
#endif /* DEPRECATED_CODE */


#endif /* NET_COMMON_H */
